import * as playwright from 'playwright';
import ConcurrencyImplementation, { ResourceData } from './ConcurrencyImplementation';
export default abstract class SingleBrowserImplementation extends ConcurrencyImplementation {
    protected browser: playwright.Browser | null;
    private repairing;
    private repairRequested;
    private openInstances;
    private waitingForRepairResolvers;
    constructor(options: playwright.LaunchOptions, playwright: playwright.BrowserType<{}>, pageOptions: playwright.BrowserContextOptions | undefined);
    private repair;
    init(): Promise<void>;
    close(): Promise<void>;
    protected abstract createResources(): Promise<ResourceData>;
    protected abstract freeResources(resources: ResourceData): Promise<void>;
    workerInstance(): Promise<{
        jobInstance: () => Promise<{
            resources: ResourceData;
            close: () => Promise<void>;
        }>;
        close: () => Promise<void>;
        repair: () => Promise<void>;
    }>;
}
